    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2007, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * --------------------
    028     * YIntervalSeries.java
    029     * --------------------
    030     * (C) Copyright 2006, 2007, by Object Refinery Limited.
    031     *
    032     * Original Author:  David Gilbert (for Object Refinery Limited);
    033     * Contributor(s):   -;
    034     *
    035     * $Id: YIntervalSeries.java,v 1.1.2.3 2007/02/20 16:22:01 mungady Exp $
    036     *
    037     * Changes
    038     * -------
    039     * 20-Oct-2006 : Version 1 (DG);
    040     * 20-Feb-2007 : Added getYHighValue() and getYLowValue() methods (DG);
    041     *
    042     */
    043
    044    package org.jfree.data.xy;
    045
    046    import org.jfree.data.ComparableObjectItem;
    047    import org.jfree.data.ComparableObjectSeries;
    048
    049    /**
    050     * A list of (x, y, y-low, y-high) data items.
    051     *
    052     * @since 1.0.3
    053     *
    054     * @see YIntervalSeriesCollection
    055     */
    056    public class YIntervalSeries extends ComparableObjectSeries {
    057
    058        /**
    059         * Creates a new empty series.  By default, items added to the series will
    060         * be sorted into ascending order by x-value, and duplicate x-values will
    061         * be allowed (these defaults can be modified with another constructor.
    062         *
    063         * @param key  the series key (<code>null</code> not permitted).
    064         */
    065        public YIntervalSeries(Comparable key) {
    066            this(key, true, true);
    067        }
    068
    069        /**
    070         * Constructs a new xy-series that contains no data.  You can specify
    071         * whether or not duplicate x-values are allowed for the series.
    072         *
    073         * @param key  the series key (<code>null</code> not permitted).
    074         * @param autoSort  a flag that controls whether or not the items in the
    075         *                  series are sorted.
    076         * @param allowDuplicateXValues  a flag that controls whether duplicate
    077         *                               x-values are allowed.
    078         */
    079        public YIntervalSeries(Comparable key, boolean autoSort,
    080                boolean allowDuplicateXValues) {
    081            super(key, autoSort, allowDuplicateXValues);
    082        }
    083
    084        /**
    085         * Adds a data item to the series.
    086         *
    087         * @param x  the x-value.
    088         * @param y  the y-value.
    089         * @param yLow  the lower bound of the y-interval.
    090         * @param yHigh  the upper bound of the y-interval.
    091         */
    092        public void add(double x, double y, double yLow, double yHigh) {
    093            super.add(new YIntervalDataItem(x, y, yLow, yHigh), true);
    094        }
    095
    096        /**
    097         * Returns the x-value for the specified item.
    098         *
    099         * @param index  the item index.
    100         *
    101         * @return The x-value (never <code>null</code>).
    102         */
    103        public Number getX(int index) {
    104            YIntervalDataItem item = (YIntervalDataItem) getDataItem(index);
    105            return item.getX();
    106        }
    107
    108        /**
    109         * Returns the y-value for the specified item.
    110         *
    111         * @param index  the item index.
    112         *
    113         * @return The y-value.
    114         */
    115        public double getYValue(int index) {
    116            YIntervalDataItem item = (YIntervalDataItem) getDataItem(index);
    117            return item.getYValue();
    118        }
    119
    120        /**
    121         * Returns the lower bound of the Y-interval for the specified item in the
    122         * series.
    123         *
    124         * @param index  the item index.
    125         *
    126         * @return The lower bound of the Y-interval.
    127         *
    128         * @since 1.0.5
    129         */
    130        public double getYLowValue(int index) {
    131            YIntervalDataItem item = (YIntervalDataItem) getDataItem(index);
    132            return item.getYLowValue();
    133        }
    134
    135        /**
    136         * Returns the upper bound of the y-interval for the specified item in the
    137         * series.
    138         *
    139         * @param index  the item index.
    140         *
    141         * @return The upper bound of the y-interval.
    142         *
    143         * @since 1.0.5
    144         */
    145        public double getYHighValue(int index) {
    146            YIntervalDataItem item = (YIntervalDataItem) getDataItem(index);
    147            return item.getYHighValue();
    148        }
    149
    150        /**
    151         * Returns the data item at the specified index.
    152         *
    153         * @param index  the item index.
    154         *
    155         * @return The data item.
    156         */
    157        public ComparableObjectItem getDataItem(int index) {
    158            return super.getDataItem(index);
    159        }
    160
    161    }